"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __markAsModule = (target) => __defProp(target, "__esModule", { value: true });
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, { get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable });
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? { get: () => module2.default, enumerable: true } : { value: module2, enumerable: true })), module2);
};

// src/index.ts
__export(exports, {
  default: () => solidReactivityPlugin
});

// src/label-parser.ts
var import_helper_module_imports = __toModule(require("@babel/helper-module-imports"));
var t = __toModule(require("@babel/types"));
function getHookIdentifier(hooks, path, name) {
  const current = hooks.get(name);
  if (current) {
    return current;
  }
  const newID = (0, import_helper_module_imports.addNamed)(path, name, "solid-js");
  hooks.set(name, newID);
  return newID;
}
function signalSingleExpression(hooks, path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  const expr = t.variableDeclaration("const", [t.variableDeclarator(t.arrayPattern([
    readIdentifier,
    writeIdentifier
  ]), t.callExpression(getHookIdentifier(hooks, path, "createSignal"), [
    stateIdentifier,
    t.objectExpression([
      t.objectProperty(t.identifier("name"), t.stringLiteral(signalIdentifier.name))
    ])
  ]))]);
  path.insertAfter(expr);
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t.isIdentifier(p.node.key) && p.node.key.name === signalIdentifier.name && t.isIdentifier(p.node.value) && p.node.value.name === signalIdentifier.name) {
          p.replaceWith(t.objectProperty(signalIdentifier, t.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== signalIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isVariableDeclarator(p.parent)) {
          if (p.parent.id === p.node) {
            return;
          }
        }
        if (t.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t.callExpression(readIdentifier, []));
      },
      UpdateExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t.isIdentifier(p.node.argument) && p.node.argument.name === signalIdentifier.name) {
          const param = p.scope.generateUidIdentifier("current");
          if (p.node.prefix) {
            p.replaceWith(t.callExpression(writeIdentifier, [
              t.arrowFunctionExpression([param], t.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t.numericLiteral(1)))
            ]));
          } else {
            p.replaceWith(t.callExpression(t.arrowFunctionExpression([], t.blockStatement([
              t.variableDeclaration("const", [
                t.variableDeclarator(param, t.callExpression(readIdentifier, []))
              ]),
              t.expressionStatement(t.callExpression(writeIdentifier, [
                t.arrowFunctionExpression([], t.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t.numericLiteral(1)))
              ])),
              t.returnStatement(param)
            ])), []));
          }
        }
      },
      AssignmentExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        const identifier3 = p.node.left;
        const expression = p.node.right;
        if (t.isIdentifier(identifier3) && identifier3.name === signalIdentifier.name) {
          if (p.node.operator === "=") {
            p.replaceWith(t.callExpression(writeIdentifier, [
              t.arrowFunctionExpression([], expression)
            ]));
          } else {
            const param = p.scope.generateUidIdentifier("current");
            p.replaceWith(t.callExpression(writeIdentifier, [
              t.arrowFunctionExpression([param], t.assignmentExpression(p.node.operator, param, expression))
            ]));
          }
        }
      }
    });
  }
}
function signalExpression(hooks, path, body) {
  if (t.isExpressionStatement(body)) {
    if (!t.isAssignmentExpression(body.expression)) {
      throw new Error("Expected assignment expression");
    }
    if (body.expression.operator !== "=") {
      throw new Error("Invalid assignment expression operator");
    }
    const leftExpr = body.expression.left;
    const rightExpr = body.expression.right;
    if (!t.isIdentifier(leftExpr)) {
      throw new Error("Expected identifier");
    }
    signalSingleExpression(hooks, path, leftExpr, rightExpr);
    path.remove();
  } else if (t.isVariableDeclaration(body)) {
    for (let i = body.declarations.length - 1; i >= 0; i -= 1) {
      const declarator = body.declarations[i];
      const leftExpr = declarator.id;
      const rightExpr = declarator.init;
      if (!t.isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      signalSingleExpression(hooks, path, leftExpr, rightExpr != null ? rightExpr : t.identifier("undefined"));
    }
    path.remove();
  } else {
    throw new Error("Expected assignment expression or variable declaration");
  }
}
function memoSingleExpression(hooks, path, memoIdentifier, stateIdentifier, replace = false) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  const expr = t.variableDeclaration("const", [t.variableDeclarator(readIdentifier, t.callExpression(getHookIdentifier(hooks, path, "createMemo"), [
    t.arrowFunctionExpression([], stateIdentifier),
    t.objectExpression([
      t.objectProperty(t.identifier("name"), t.stringLiteral(memoIdentifier.name))
    ])
  ]))]);
  if (replace) {
    path.replaceWith(expr);
  } else {
    path.insertAfter(expr);
  }
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t.isIdentifier(p.node.key) && p.node.key.name === memoIdentifier.name && t.isIdentifier(p.node.value) && p.node.value.name === memoIdentifier.name) {
          p.replaceWith(t.objectProperty(memoIdentifier, t.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== memoIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (t.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t.isVariableDeclarator(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t.callExpression(readIdentifier, []));
      }
    });
  }
}
function memoExpression(hooks, path, body) {
  if (t.isExpressionStatement(body)) {
    if (t.isAssignmentExpression(body.expression)) {
      if (body.expression.operator !== "=") {
        throw new Error("Invalid assignment expression operator");
      }
      const leftExpr = body.expression.left;
      const rightExpr = body.expression.right;
      if (!t.isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      memoSingleExpression(hooks, path, leftExpr, rightExpr, true);
    } else {
      throw new Error("Expected assignment expression");
    }
  } else if (t.isVariableDeclaration(body)) {
    for (let i = body.declarations.length - 1; i >= 0; i -= 1) {
      const declarator = body.declarations[i];
      const leftExpr = declarator.id;
      const rightExpr = declarator.init;
      if (!t.isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      memoSingleExpression(hooks, path, leftExpr, rightExpr != null ? rightExpr : t.identifier("undefined"));
    }
    path.remove();
  } else {
    throw new Error("Expected assignment expression or variable declaration");
  }
}
function createCallbackLabel(label) {
  return function expr(hooks, path, body) {
    let callback;
    if (t.isBlockStatement(body)) {
      callback = t.arrowFunctionExpression([], body);
    } else if (t.isExpressionStatement(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(t.callExpression(getHookIdentifier(hooks, path, label), [
      callback
    ]));
  };
}
var EXPRESSIONS = {
  signal: signalExpression,
  memo: memoExpression,
  effect: createCallbackLabel("createEffect"),
  computed: createCallbackLabel("createComputed"),
  renderEffect: createCallbackLabel("createRenderEffect"),
  mount: createCallbackLabel("onMount"),
  cleanup: createCallbackLabel("onCleanup"),
  error: createCallbackLabel("onError"),
  root: createCallbackLabel("createRoot"),
  untrack: createCallbackLabel("untrack"),
  batch: createCallbackLabel("batch")
};
var LABEL_PARSER = {
  LabeledStatement(path, state) {
    const { label, body } = path.node;
    if (label.name in EXPRESSIONS) {
      EXPRESSIONS[label.name](state.hooks, path, body);
    }
  }
};
var label_parser_default = LABEL_PARSER;

// src/comment-parser.ts
var import_helper_module_imports2 = __toModule(require("@babel/helper-module-imports"));
var t2 = __toModule(require("@babel/types"));
function getHookIdentifier2(hooks, path, name) {
  const current = hooks.get(name);
  if (current) {
    return current;
  }
  const newID = (0, import_helper_module_imports2.addNamed)(path, name, "solid-js");
  hooks.set(name, newID);
  return newID;
}
function signalSingleExpression2(hooks, path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  path.node.id = t2.arrayPattern([
    readIdentifier,
    writeIdentifier
  ]);
  path.node.init = t2.callExpression(getHookIdentifier2(hooks, path, "createSignal"), [
    stateIdentifier,
    t2.objectExpression([
      t2.objectProperty(t2.identifier("name"), t2.stringLiteral(signalIdentifier.name))
    ])
  ]);
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t2.isIdentifier(p.node.key) && p.node.key.name === signalIdentifier.name && t2.isIdentifier(p.node.value) && p.node.value.name === signalIdentifier.name) {
          p.replaceWith(t2.objectProperty(signalIdentifier, t2.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== signalIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t2.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t2.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t2.isVariableDeclarator(p.parent)) {
          if (p.parent.id === p.node) {
            return;
          }
        }
        if (t2.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t2.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t2.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t2.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t2.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t2.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t2.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t2.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t2.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t2.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t2.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t2.callExpression(readIdentifier, []));
      },
      UpdateExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (t2.isIdentifier(p.node.argument) && p.node.argument.name === signalIdentifier.name) {
          const param = p.scope.generateUidIdentifier("current");
          if (p.node.prefix) {
            p.replaceWith(t2.callExpression(writeIdentifier, [
              t2.arrowFunctionExpression([param], t2.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t2.numericLiteral(1)))
            ]));
          } else {
            p.replaceWith(t2.callExpression(t2.arrowFunctionExpression([], t2.blockStatement([
              t2.variableDeclaration("const", [
                t2.variableDeclarator(param, t2.callExpression(readIdentifier, []))
              ]),
              t2.expressionStatement(t2.callExpression(writeIdentifier, [
                t2.arrowFunctionExpression([], t2.binaryExpression(p.node.operator === "++" ? "+" : "-", param, t2.numericLiteral(1)))
              ])),
              t2.returnStatement(param)
            ])), []));
          }
        }
      },
      AssignmentExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        const identifier3 = p.node.left;
        const expression = p.node.right;
        if (t2.isIdentifier(identifier3) && identifier3.name === signalIdentifier.name) {
          if (p.node.operator === "=") {
            p.replaceWith(t2.callExpression(writeIdentifier, [
              t2.arrowFunctionExpression([], expression)
            ]));
          } else {
            const param = p.scope.generateUidIdentifier("current");
            p.replaceWith(t2.callExpression(writeIdentifier, [
              t2.arrowFunctionExpression([param], t2.assignmentExpression(p.node.operator, param, expression))
            ]));
          }
        }
      }
    });
  }
}
function signalExpression2(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (t2.isIdentifier(leftExpr)) {
        signalSingleExpression2(hooks, p, leftExpr, rightExpr != null ? rightExpr : t2.identifier("undefined"));
      }
    }
  });
}
function memoSingleExpression2(hooks, path, memoIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  path.node.id = readIdentifier;
  path.node.init = t2.callExpression(getHookIdentifier2(hooks, path, "createMemo"), [
    t2.arrowFunctionExpression([], stateIdentifier),
    t2.objectExpression([
      t2.objectProperty(t2.identifier("name"), t2.stringLiteral(memoIdentifier.name))
    ])
  ]);
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && t2.isIdentifier(p.node.key) && p.node.key.name === memoIdentifier.name && t2.isIdentifier(p.node.value) && p.node.value.name === memoIdentifier.name) {
          p.replaceWith(t2.objectProperty(memoIdentifier, t2.callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== memoIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (t2.isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t2.isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (t2.isVariableDeclarator(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t2.isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (t2.isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t2.isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t2.isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (t2.isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (t2.isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (t2.isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (t2.isAssignmentPattern(p.parent) && p.parent.left === p.node && (t2.isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t2.isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || t2.isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(t2.callExpression(readIdentifier, []));
      }
    });
  }
}
function memoExpression2(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (t2.isIdentifier(leftExpr)) {
        memoSingleExpression2(hooks, p, leftExpr, rightExpr != null ? rightExpr : t2.identifier("undefined"));
      }
    }
  });
}
function createCallbackLabel2(label) {
  return function expr(hooks, path) {
    const body = path.node;
    let callback;
    if (t2.isBlockStatement(body)) {
      callback = t2.arrowFunctionExpression([], body);
    } else if (t2.isExpressionStatement(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(t2.callExpression(getHookIdentifier2(hooks, path, label), [
      callback
    ]));
  };
}
var STATE_EXPRESSIONS = {
  "@signal": signalExpression2,
  "@memo": memoExpression2
};
var CALLBACK_EXPRESSIONS = {
  "@effect": createCallbackLabel2("createEffect"),
  "@computed": createCallbackLabel2("createComputed"),
  "@renderEffect": createCallbackLabel2("createRenderEffect"),
  "@mount": createCallbackLabel2("onMount"),
  "@cleanup": createCallbackLabel2("onCleanup"),
  "@error": createCallbackLabel2("onError"),
  "@root": createCallbackLabel2("createRoot"),
  "@untrack": createCallbackLabel2("untrack"),
  "@batch": createCallbackLabel2("batch")
};
var COMMENT_PARSER = {
  VariableDeclaration(path, state) {
    const comments = path.node.leadingComments;
    if (comments) {
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in STATE_EXPRESSIONS) {
          preference = value;
        }
      }
      if (preference) {
        STATE_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  BlockStatement(path, state) {
    var _a, _b;
    if (t2.isFunctionDeclaration(path.parent)) {
      return;
    }
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      t2.removeComments(path.node);
      t2.addComments(path.node, "leading", leading);
      t2.addComments(path.node, "inner", inner);
      t2.addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  ExpressionStatement(path, state) {
    var _a, _b;
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      t2.removeComments(path.node);
      t2.addComments(path.node, "leading", leading);
      t2.addComments(path.node, "inner", inner);
      t2.addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  }
};
var comment_parser_default = COMMENT_PARSER;

// src/index.ts
function solidReactivityPlugin() {
  return {
    pre() {
      this.hooks = new Map();
    },
    visitor: __spreadValues(__spreadValues({}, label_parser_default), comment_parser_default)
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
//# sourceMappingURL=index.js.map
