var __defProp = Object.defineProperty;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __spreadValues = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __require = typeof require !== "undefined" ? require : (x) => {
  throw new Error('Dynamic require of "' + x + '" is not supported');
};

// src/label-parser.ts
import { addNamed } from "@babel/helper-module-imports";
import {
  arrayPattern,
  arrowFunctionExpression,
  assignmentExpression,
  binaryExpression,
  blockStatement,
  callExpression,
  expressionStatement,
  identifier,
  isArrayPattern,
  isArrowFunctionExpression,
  isAssignmentExpression,
  isAssignmentPattern,
  isBlockStatement,
  isExpressionStatement,
  isFunctionDeclaration,
  isFunctionExpression,
  isIdentifier,
  isLabeledStatement,
  isMemberExpression,
  isObjectMethod,
  isObjectProperty,
  isVariableDeclaration,
  isVariableDeclarator,
  numericLiteral,
  objectExpression,
  objectProperty,
  returnStatement,
  stringLiteral,
  variableDeclaration,
  variableDeclarator
} from "@babel/types";
function getHookIdentifier(hooks, path, name) {
  const current = hooks.get(name);
  if (current) {
    return current;
  }
  const newID = addNamed(path, name, "solid-js");
  hooks.set(name, newID);
  return newID;
}
function signalSingleExpression(hooks, path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  const expr = variableDeclaration("const", [variableDeclarator(arrayPattern([
    readIdentifier,
    writeIdentifier
  ]), callExpression(getHookIdentifier(hooks, path, "createSignal"), [
    stateIdentifier,
    objectExpression([
      objectProperty(identifier("name"), stringLiteral(signalIdentifier.name))
    ])
  ]))]);
  path.insertAfter(expr);
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && isIdentifier(p.node.key) && p.node.key.name === signalIdentifier.name && isIdentifier(p.node.value) && p.node.value.name === signalIdentifier.name) {
          p.replaceWith(objectProperty(signalIdentifier, callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== signalIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isVariableDeclarator(p.parent)) {
          if (p.parent.id === p.node) {
            return;
          }
        }
        if (isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (isAssignmentPattern(p.parent) && p.parent.left === p.node && (isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(callExpression(readIdentifier, []));
      },
      UpdateExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (isIdentifier(p.node.argument) && p.node.argument.name === signalIdentifier.name) {
          const param = p.scope.generateUidIdentifier("current");
          if (p.node.prefix) {
            p.replaceWith(callExpression(writeIdentifier, [
              arrowFunctionExpression([param], binaryExpression(p.node.operator === "++" ? "+" : "-", param, numericLiteral(1)))
            ]));
          } else {
            p.replaceWith(callExpression(arrowFunctionExpression([], blockStatement([
              variableDeclaration("const", [
                variableDeclarator(param, callExpression(readIdentifier, []))
              ]),
              expressionStatement(callExpression(writeIdentifier, [
                arrowFunctionExpression([], binaryExpression(p.node.operator === "++" ? "+" : "-", param, numericLiteral(1)))
              ])),
              returnStatement(param)
            ])), []));
          }
        }
      },
      AssignmentExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        const identifier3 = p.node.left;
        const expression = p.node.right;
        if (isIdentifier(identifier3) && identifier3.name === signalIdentifier.name) {
          if (p.node.operator === "=") {
            p.replaceWith(callExpression(writeIdentifier, [
              arrowFunctionExpression([], expression)
            ]));
          } else {
            const param = p.scope.generateUidIdentifier("current");
            p.replaceWith(callExpression(writeIdentifier, [
              arrowFunctionExpression([param], assignmentExpression(p.node.operator, param, expression))
            ]));
          }
        }
      }
    });
  }
}
function signalExpression(hooks, path, body) {
  if (isExpressionStatement(body)) {
    if (!isAssignmentExpression(body.expression)) {
      throw new Error("Expected assignment expression");
    }
    if (body.expression.operator !== "=") {
      throw new Error("Invalid assignment expression operator");
    }
    const leftExpr = body.expression.left;
    const rightExpr = body.expression.right;
    if (!isIdentifier(leftExpr)) {
      throw new Error("Expected identifier");
    }
    signalSingleExpression(hooks, path, leftExpr, rightExpr);
    path.remove();
  } else if (isVariableDeclaration(body)) {
    for (let i = body.declarations.length - 1; i >= 0; i -= 1) {
      const declarator = body.declarations[i];
      const leftExpr = declarator.id;
      const rightExpr = declarator.init;
      if (!isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      signalSingleExpression(hooks, path, leftExpr, rightExpr != null ? rightExpr : identifier("undefined"));
    }
    path.remove();
  } else {
    throw new Error("Expected assignment expression or variable declaration");
  }
}
function memoSingleExpression(hooks, path, memoIdentifier, stateIdentifier, replace = false) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  const expr = variableDeclaration("const", [variableDeclarator(readIdentifier, callExpression(getHookIdentifier(hooks, path, "createMemo"), [
    arrowFunctionExpression([], stateIdentifier),
    objectExpression([
      objectProperty(identifier("name"), stringLiteral(memoIdentifier.name))
    ])
  ]))]);
  if (replace) {
    path.replaceWith(expr);
  } else {
    path.insertAfter(expr);
  }
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && isIdentifier(p.node.key) && p.node.key.name === memoIdentifier.name && isIdentifier(p.node.value) && p.node.value.name === memoIdentifier.name) {
          p.replaceWith(objectProperty(memoIdentifier, callExpression(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== memoIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (isObjectMethod(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isObjectProperty(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isVariableDeclarator(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (isArrayPattern(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (isArrowFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionExpression(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionDeclaration(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isLabeledStatement(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (isMemberExpression(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (isFunctionDeclaration(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (isAssignmentPattern(p.parent) && p.parent.left === p.node && (isArrowFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionDeclaration(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionExpression(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(callExpression(readIdentifier, []));
      }
    });
  }
}
function memoExpression(hooks, path, body) {
  if (isExpressionStatement(body)) {
    if (isAssignmentExpression(body.expression)) {
      if (body.expression.operator !== "=") {
        throw new Error("Invalid assignment expression operator");
      }
      const leftExpr = body.expression.left;
      const rightExpr = body.expression.right;
      if (!isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      memoSingleExpression(hooks, path, leftExpr, rightExpr, true);
    } else {
      throw new Error("Expected assignment expression");
    }
  } else if (isVariableDeclaration(body)) {
    for (let i = body.declarations.length - 1; i >= 0; i -= 1) {
      const declarator = body.declarations[i];
      const leftExpr = declarator.id;
      const rightExpr = declarator.init;
      if (!isIdentifier(leftExpr)) {
        throw new Error("Expected identifier");
      }
      memoSingleExpression(hooks, path, leftExpr, rightExpr != null ? rightExpr : identifier("undefined"));
    }
    path.remove();
  } else {
    throw new Error("Expected assignment expression or variable declaration");
  }
}
function createCallbackLabel(label) {
  return function expr(hooks, path, body) {
    let callback;
    if (isBlockStatement(body)) {
      callback = arrowFunctionExpression([], body);
    } else if (isExpressionStatement(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(callExpression(getHookIdentifier(hooks, path, label), [
      callback
    ]));
  };
}
var EXPRESSIONS = {
  signal: signalExpression,
  memo: memoExpression,
  effect: createCallbackLabel("createEffect"),
  computed: createCallbackLabel("createComputed"),
  renderEffect: createCallbackLabel("createRenderEffect"),
  mount: createCallbackLabel("onMount"),
  cleanup: createCallbackLabel("onCleanup"),
  error: createCallbackLabel("onError"),
  root: createCallbackLabel("createRoot"),
  untrack: createCallbackLabel("untrack"),
  batch: createCallbackLabel("batch")
};
var LABEL_PARSER = {
  LabeledStatement(path, state) {
    const { label, body } = path.node;
    if (label.name in EXPRESSIONS) {
      EXPRESSIONS[label.name](state.hooks, path, body);
    }
  }
};
var label_parser_default = LABEL_PARSER;

// src/comment-parser.ts
import { addNamed as addNamed2 } from "@babel/helper-module-imports";
import {
  addComments,
  arrayPattern as arrayPattern2,
  arrowFunctionExpression as arrowFunctionExpression2,
  assignmentExpression as assignmentExpression2,
  binaryExpression as binaryExpression2,
  blockStatement as blockStatement2,
  callExpression as callExpression2,
  expressionStatement as expressionStatement2,
  identifier as identifier2,
  isArrayPattern as isArrayPattern2,
  isArrowFunctionExpression as isArrowFunctionExpression2,
  isAssignmentPattern as isAssignmentPattern2,
  isBlockStatement as isBlockStatement2,
  isExpressionStatement as isExpressionStatement2,
  isFunctionDeclaration as isFunctionDeclaration2,
  isFunctionExpression as isFunctionExpression2,
  isIdentifier as isIdentifier2,
  isLabeledStatement as isLabeledStatement2,
  isMemberExpression as isMemberExpression2,
  isObjectMethod as isObjectMethod2,
  isObjectProperty as isObjectProperty2,
  isVariableDeclarator as isVariableDeclarator2,
  numericLiteral as numericLiteral2,
  objectExpression as objectExpression2,
  objectProperty as objectProperty2,
  removeComments,
  returnStatement as returnStatement2,
  stringLiteral as stringLiteral2,
  variableDeclaration as variableDeclaration2,
  variableDeclarator as variableDeclarator2
} from "@babel/types";
function getHookIdentifier2(hooks, path, name) {
  const current = hooks.get(name);
  if (current) {
    return current;
  }
  const newID = addNamed2(path, name, "solid-js");
  hooks.set(name, newID);
  return newID;
}
function signalSingleExpression2(hooks, path, signalIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(signalIdentifier.name);
  const writeIdentifier = path.scope.generateUidIdentifier(`set${signalIdentifier.name}`);
  path.node.id = arrayPattern2([
    readIdentifier,
    writeIdentifier
  ]);
  path.node.init = callExpression2(getHookIdentifier2(hooks, path, "createSignal"), [
    stateIdentifier,
    objectExpression2([
      objectProperty2(identifier2("name"), stringLiteral2(signalIdentifier.name))
    ])
  ]);
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && isIdentifier2(p.node.key) && p.node.key.name === signalIdentifier.name && isIdentifier2(p.node.value) && p.node.value.name === signalIdentifier.name) {
          p.replaceWith(objectProperty2(signalIdentifier, callExpression2(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== signalIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (isObjectMethod2(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isObjectProperty2(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isVariableDeclarator2(p.parent)) {
          if (p.parent.id === p.node) {
            return;
          }
        }
        if (isArrayPattern2(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (isArrowFunctionExpression2(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionExpression2(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionDeclaration2(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isLabeledStatement2(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (isMemberExpression2(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (isFunctionDeclaration2(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (isAssignmentPattern2(p.parent) && p.parent.left === p.node && (isArrowFunctionExpression2(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionDeclaration2(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionExpression2(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(callExpression2(readIdentifier, []));
      },
      UpdateExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        if (isIdentifier2(p.node.argument) && p.node.argument.name === signalIdentifier.name) {
          const param = p.scope.generateUidIdentifier("current");
          if (p.node.prefix) {
            p.replaceWith(callExpression2(writeIdentifier, [
              arrowFunctionExpression2([param], binaryExpression2(p.node.operator === "++" ? "+" : "-", param, numericLiteral2(1)))
            ]));
          } else {
            p.replaceWith(callExpression2(arrowFunctionExpression2([], blockStatement2([
              variableDeclaration2("const", [
                variableDeclarator2(param, callExpression2(readIdentifier, []))
              ]),
              expressionStatement2(callExpression2(writeIdentifier, [
                arrowFunctionExpression2([], binaryExpression2(p.node.operator === "++" ? "+" : "-", param, numericLiteral2(1)))
              ])),
              returnStatement2(param)
            ])), []));
          }
        }
      },
      AssignmentExpression(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(signalIdentifier.name)) {
          return;
        }
        const identifier3 = p.node.left;
        const expression = p.node.right;
        if (isIdentifier2(identifier3) && identifier3.name === signalIdentifier.name) {
          if (p.node.operator === "=") {
            p.replaceWith(callExpression2(writeIdentifier, [
              arrowFunctionExpression2([], expression)
            ]));
          } else {
            const param = p.scope.generateUidIdentifier("current");
            p.replaceWith(callExpression2(writeIdentifier, [
              arrowFunctionExpression2([param], assignmentExpression2(p.node.operator, param, expression))
            ]));
          }
        }
      }
    });
  }
}
function signalExpression2(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (isIdentifier2(leftExpr)) {
        signalSingleExpression2(hooks, p, leftExpr, rightExpr != null ? rightExpr : identifier2("undefined"));
      }
    }
  });
}
function memoSingleExpression2(hooks, path, memoIdentifier, stateIdentifier) {
  const readIdentifier = path.scope.generateUidIdentifier(memoIdentifier.name);
  path.node.id = readIdentifier;
  path.node.init = callExpression2(getHookIdentifier2(hooks, path, "createMemo"), [
    arrowFunctionExpression2([], stateIdentifier),
    objectExpression2([
      objectProperty2(identifier2("name"), stringLiteral2(memoIdentifier.name))
    ])
  ]);
  const parent = path.scope.path;
  if (parent) {
    parent.traverse({
      ObjectProperty(p) {
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (p.node.shorthand && isIdentifier2(p.node.key) && p.node.key.name === memoIdentifier.name && isIdentifier2(p.node.value) && p.node.value.name === memoIdentifier.name) {
          p.replaceWith(objectProperty2(memoIdentifier, callExpression2(readIdentifier, [])));
        }
      },
      Identifier(p) {
        if (p.node.name !== memoIdentifier.name) {
          return;
        }
        if (p.scope !== path.scope && p.scope.hasOwnBinding(memoIdentifier.name)) {
          return;
        }
        if (isObjectMethod2(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isObjectProperty2(p.parent) && p.parent.key === p.node) {
          return;
        }
        if (isVariableDeclarator2(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (isArrayPattern2(p.parent) && p.parent.elements.includes(p.node)) {
          return;
        }
        if (isArrowFunctionExpression2(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionExpression2(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isFunctionDeclaration2(p.parent) && p.parent.params.includes(p.node)) {
          return;
        }
        if (isLabeledStatement2(p.parent) && p.parent.label === p.node) {
          return;
        }
        if (isMemberExpression2(p.parent) && p.parent.property === p.node) {
          return;
        }
        if (isFunctionDeclaration2(p.parent) && p.parent.id === p.node) {
          return;
        }
        if (isAssignmentPattern2(p.parent) && p.parent.left === p.node && (isArrowFunctionExpression2(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionDeclaration2(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent) || isFunctionExpression2(p.parentPath.parent) && p.parentPath.parent.params.includes(p.parent))) {
          return;
        }
        p.replaceWith(callExpression2(readIdentifier, []));
      }
    });
  }
}
function memoExpression2(hooks, path) {
  path.traverse({
    VariableDeclarator(p) {
      const leftExpr = p.node.id;
      const rightExpr = p.node.init;
      if (isIdentifier2(leftExpr)) {
        memoSingleExpression2(hooks, p, leftExpr, rightExpr != null ? rightExpr : identifier2("undefined"));
      }
    }
  });
}
function createCallbackLabel2(label) {
  return function expr(hooks, path) {
    const body = path.node;
    let callback;
    if (isBlockStatement2(body)) {
      callback = arrowFunctionExpression2([], body);
    } else if (isExpressionStatement2(body)) {
      callback = body.expression;
    } else {
      throw new Error("Expected arrow function or block expression");
    }
    path.replaceWith(callExpression2(getHookIdentifier2(hooks, path, label), [
      callback
    ]));
  };
}
var STATE_EXPRESSIONS = {
  "@signal": signalExpression2,
  "@memo": memoExpression2
};
var CALLBACK_EXPRESSIONS = {
  "@effect": createCallbackLabel2("createEffect"),
  "@computed": createCallbackLabel2("createComputed"),
  "@renderEffect": createCallbackLabel2("createRenderEffect"),
  "@mount": createCallbackLabel2("onMount"),
  "@cleanup": createCallbackLabel2("onCleanup"),
  "@error": createCallbackLabel2("onError"),
  "@root": createCallbackLabel2("createRoot"),
  "@untrack": createCallbackLabel2("untrack"),
  "@batch": createCallbackLabel2("batch")
};
var COMMENT_PARSER = {
  VariableDeclaration(path, state) {
    const comments = path.node.leadingComments;
    if (comments) {
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in STATE_EXPRESSIONS) {
          preference = value;
        }
      }
      if (preference) {
        STATE_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  BlockStatement(path, state) {
    var _a, _b;
    if (isFunctionDeclaration2(path.parent)) {
      return;
    }
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      removeComments(path.node);
      addComments(path.node, "leading", leading);
      addComments(path.node, "inner", inner);
      addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  },
  ExpressionStatement(path, state) {
    var _a, _b;
    const comments = path.node.leadingComments;
    if (comments) {
      const leading = [];
      let preference;
      for (let i = 0, len = comments.length; i < len; i += 1) {
        const comment = comments[i];
        const value = comment.value.trim();
        if (value in CALLBACK_EXPRESSIONS) {
          preference = value;
        } else {
          leading.push(comment);
        }
      }
      const trailing = [...(_a = path.node.trailingComments) != null ? _a : []];
      const inner = [...(_b = path.node.innerComments) != null ? _b : []];
      removeComments(path.node);
      addComments(path.node, "leading", leading);
      addComments(path.node, "inner", inner);
      addComments(path.node, "trailing", trailing);
      if (preference) {
        CALLBACK_EXPRESSIONS[preference](state.hooks, path);
      }
    }
  }
};
var comment_parser_default = COMMENT_PARSER;

// src/index.ts
function solidReactivityPlugin() {
  return {
    pre() {
      this.hooks = new Map();
    },
    visitor: __spreadValues(__spreadValues({}, label_parser_default), comment_parser_default)
  };
}
export {
  solidReactivityPlugin as default
};
//# sourceMappingURL=index.js.map
